# FlexRIC Subscription DoS Attack

With this repo it is possible to perform the E2 Subscription DoS attack on the FlexRIC Near-RT RIC implementation.  
There are two execution modes, which save their results or logs under the following order structure:

```shell
dos
├── logs
│   └── 2024-04-12_11-20-27
│       ├── dos_xApp.log
│       ├── gnb_cu.log
│       ├── gnb_du.log
│       └── nearRT.log
├── measurements
│   └── 2024-04-12_11-20-27
│       ├── combined_cpu_usage.png
│       ├── cpu_usage.txt
│       ├── gtp.txt
│       ├── kpm_moni.txt
│       ├── mac.txt
│       ├── pdcp.txt
│       └── rlc.txt
```


## Requirements

In order to run the experiments, `make`, `docker` and `docker compose` must be installed. Installation instructions for docker can be found here: https://docs.docker.com/compose/install/

To install `make` you can use the following:

Linux:
```shell
sudo apt-get -y install make
```
MacOS:
```shell
brew install make
```
Windows:
```shell
choco install make
```
## Baseline Measurement
To execute the baseline measurement without executing the DoS script, you can either build and execute the container using `docker compose` or using:
```shell
make baseline
```
You should then find the corresponding measurement logs data and the following CPU usage plot as a png under measurements.

![Baseline Plot](misc/baseline_cpu_usage.png)


## DoS Attack
To carry out the actual attack, you can either run everything separately using `docker compose` as above or use the `make` command:

```shell
make dos
```

You should then also find the corresponding measurement data and the following CPU usage diagram as a png under measurements as well as all other logs, similar to the baseline measurement case.

![Baseline Plot](misc/dos_cpu_usage.png)


## DoS Prevention
If our implemented DoS prevention wants to be tested, the argument `DOS_PREV_ENABL` must be set from `0` (disabled)(default) to `1` (enabled)  

### For the DoS Attack
```bash
make dos DOS_PREV_ENABL=1
```

### For the Baseline
```bash
make baseline DOS_PREV_ENABL=1
```
